##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/all.4gs/al_chrtz.4gl  1.4  Last Delta: 12/11/89
##############################################################################

database standard

############################################################
function al_chrtz()
# returns account number.
############################################################
# This function displays a zoom window to the chart of 
# accounts table and permits selection of the account
# number which it then returns.
#

define
    acct_no            like stxchrtr.acct_no

    open window cwindo at 8, 10
        with form "../../lib.4gm/all.4gs/al_chrtz"
            attribute (border, blue)

        call menu_line()
        call chrt_ctg() returning acct_no

    close window cwindo

    return acct_no

end function
# charzoom

############################################################
function chrt_ctg()
############################################################
# This function displays the menu for selecting type of 
# accounts to display and returns the selected account 
# number to function al_chrtz.
#
    define
        acct_no                 like stxchrtr.acct_no,
        department              like stxchrtd.department,
        category                char(1)

    let acct_no = ""

    menu " Account Types"

        command "Asst" " Current & Fixed Assets"
                let category="A"
                exit menu
        command "Lia" " Current and Long Term Liabilities"
                let category="B"
                exit menu
        command "Cap" " Capital"
                let category="C"
                exit menu
        command "Inc" " Income"
                let category="D"
                exit menu
        command "Gds" " Cost of Goods Sold"
                let category="E"
                exit menu
        command "Opex" " Operation Expenses"
                let category="F"
                exit menu
        command key(e,x,q,interrupt) "Quit" " Return to previous window"
                let int_flag = 1
                exit menu
        command key ("!")
            call ring_bang()
    end menu

    if int_flag != 0
      then let int_flag = 0
      else call chrtlist(category) returning acct_no
    end if

    return acct_no

end function
# chrt_ctg

############################################################
function chrtlist(category)
############################################################
# This function displays the chart of accounts for 
# function chrt_ctg.
#

    define
        category char(1),
        chart array[100] of record
            acct_no             like stxchrtr.acct_no,
            description         like stxchrtr.acct_desc,
            inc_cr              like stxchrtr.incr_with_crdt
        end record,
        counter  smallint,
        pcurr    smallint,
        scurr    smallint

    let pcurr = arr_curr()
    let scurr = scr_line()

    display " Select account number and press [ESC] to choose            " at 1,1
    display " [DOWN ARROW] or [UP ARROW] to Scroll,  [F3] or [F4] to Page" at 2,1

    declare chart_list cursor for
        select acct_no, acct_desc, incr_with_crdt
            from stxchrtr
                where stxchrtr.acct_cat = category
                order by acct_no

    let counter = 1

    foreach chart_list
        into chart[counter].*
        let counter = counter + 1
        if counter > 100
        then
            exit foreach
        end if
    end foreach

    call set_count(counter -1)

    display array chart to s_gchrtr.*
        on key (control-f)
            let counter = arr_curr()
            call al_addlz("stxchrtr",chart[counter].acct_no, "", "")
    end display


    let counter = arr_curr()

    if int_flag != 0
    then
        let chart[counter].acct_no = ""
        let int_flag = 0
        return chart[counter].acct_no
    end if

    return chart[counter].acct_no

end function
# chrtlist
