#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/all.4gs/dec_str.4gl  1.2  Delta: 10/24/89
#####################################################################


######################################################################
function dec_to_str(dec_val)
# returns a string representation of the decimal value
######################################################################
#   This function takes a decimal argument (max. 18,8) and converts
#   it to a string value. If the argument is null a null string is
#   returned, otherwise the string representation of the value is
#   returned. For example, this function returns the strings "0.0",
#   "12.0", "0.009", and "-0.87" for the appropriate decimal values.
#
    define
        dec_val decimal(18,8),
        left_val integer,
        right_val integer,
        r_val decimal(8,8),
        zero_str char(20),
        result_str char(27),
        neg_flag smallint

    # check for null and zero values
    if dec_val is null
    then
        return ""
    end if
    if dec_val = 0
    then
        return "0.0"
    end if

    # check for negative value
    if dec_val < 0
    then
        let neg_flag = true
        let dec_val = dec_val * (-1)
    else
        let neg_flag = false
    end if

    # break out the left and right sides
    let left_val = dec_val
    let r_val = dec_val - left_val

    # determine the r_val precision (strip trailing zeros)
    let right_val = r_val * 100000000
    while right_val mod 10 = 0 and right_val > 0
        let right_val = right_val / 10
    end while

    # determine the r_val left zero count
    case
        when r_val >= .10000000 let zero_str = "."
        when r_val >= .01000000 let zero_str = ".0"
        when r_val >= .00100000 let zero_str = ".00"
        when r_val >= .00010000 let zero_str = ".000"
        when r_val >= .00001000 let zero_str = ".0000"
        when r_val >= .00000100 let zero_str = ".00000"
        when r_val >= .00000010 let zero_str = ".000000"
        when r_val >= .00000001 let zero_str = ".0000000"
        otherwise               let zero_str = ".0"
    end case

    # if left side is zero make sure it prints a zero
    if left_val = 0
    then
        let zero_str = "0", zero_str clipped
    end if

    # return the resulting string
    let result_str = left_val using "<<<<<<<<<<", zero_str clipped,
        right_val using "<<<<<<<<"
    if neg_flag
    then
        let result_str = "-", result_str clipped
    end if
    return result_str
end function
# dec_to_str()

