########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/all.4gs/del_trx.4gl  1.3  Delta: 9/4/90
########################################################################
 
database standard

##################################################################
function del_trx(p_orig_journal, p_doc_no)
# deletes a row in the stxtranr table
##################################################################
# This function is passed a journal code and a document number
# which are used to delete a row in table stxtranr if there
# is no other st?tranr row that is tied to it.
#
    define
        p_orig_journal char(2),
        p_doc_no integer, 
        p_table char(8), 
        deltrx_flag smallint,
        select_1 char(128),
        quote char(1)
     
    let deltrx_flag = true
    let quote = "\""

    declare table_curs cursor for
        select tabname from systables 
            where systables.tabname matches "st?tranr" 

    foreach table_curs into p_table
        if p_table != "stxtranr"
        then
            let select_1 = "select rowid from ",p_table,
                           " where ",p_table,
                           ".orig_journal = ", quote, p_orig_journal, quote,
                           " and ",p_table, ".doc_no = ", p_doc_no
            prepare query_1 from select_1
            whenever error continue
            execute query_1
            whenever error call error_handler
            if sqlca.sqlcode = 0
            then
                let deltrx_flag = false
                exit foreach
            else
                let sqlca.sqlcode = 0
            end if
         end if
    end foreach 

    if deltrx_flag
    then
        delete from stxtranr 
            where stxtranr.orig_journal = p_orig_journal and
                  stxtranr.doc_no = p_doc_no
    end if

end function
