##############################################################################
# Copyright 1988 Fourgen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/all.4gs/fg_error.4gl  1.1  Last Delta: 10/25/88
##############################################################################

globals "globals.4gl"

############################################################
function fg_error(err_mod, err_prog, err_num)
# error message management
############################################################
# This function is passed the error module name, the error
# program name and the error number and calls function fg_err.
# This routine allows the program to explicitly define
# the error module and error program.  It can be used if
# a library function needs error text, or if error text is
# shared between programs.
# It builds the progid, then calls fg_err, then resets progid.
#
    define
        err_mod     char(8),    # module name
        err_prog    char(8),    # program name within the module
        err_num     smallint,   # error number within the program
        old_progid  char(17)    # hold space for progid

    let old_progid = progid
    let progid = err_mod clipped, ".", err_prog clipped
    call fg_err(err_num)
    let progid = old_progid

end function
# fg_error()
