#####################################################################
# Copyright (C) 1988,1989
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/all.4gs/fg_help.4gl  1.6  Delta: 4/5/90
#####################################################################

globals "globals.4gl"

define
    m_xhelpd    record like stxhelpd.*, # record like hlp file
    p_xhelpd array[100] of record       # record like the detail screen
        hlp_text like stxhelpd.hlp_text
        end record,
    rec1_cnt    smallint                # number of records in the array

#####################################################################
function fg_help(hlp_num)
#####################################################################
# This function displays a help message to the user and also
# has options for updating the message and copying a help 
# message from another source, and showing a hardcoded help for
# the informix function keys.
#
    define
        hlp_mod     char(8),    # module name
        hlp_prog    char(8),    # program name within the module
        hlp_num     smallint,   # hlpor number within the program
        ere_mod     char(8),    # module name (entered)
        ere_prog    char(8),    # program name within the module (entered)
        ere_num     smallint    # error number within the program (entered)

    call get_mod() returning hlp_mod, hlp_prog

    open window hlptxtwin at 4, 8 with 18 rows, 66 columns
        attribute (border, white)
    open form hlptxt from "../../lib.4gm/all.4gs/hlptxt"
    display form hlptxt attribute(blue)
    call menu_line()

    call hlp_read(hlp_mod, hlp_prog, hlp_num)

    menu " Action"
        command key (control-i,t,v)
            "View" " View help text"
            call ring_clear()
            display "Scroll:  [TAB], [DEL], or [ESC]  to Quit"
                at 1,2
            display "[DOWN ARROW] or [UP ARROW] to Scroll, [F3] or [F4] to Page"
                at 2,2
            if rec1_cnt > 0
            then
                call set_count(rec1_cnt)
                display array p_xhelpd to s_xhelpd.*
                    on key(control-i)
                        exit display
                end display
            end if
            let int_flag = 0

        command key (control-c)
            # copy from another text...
            let int_flag = 0
            prompt " COPY: Enter module to copy from: " for ere_mod
            prompt " COPY: Enter program name: " for ere_prog
            prompt " COPY: Enter error number: " for ere_num
            if int_flag != 0
            then
                let int_flag = 0
                continue menu
            end if
            call hlp_read(ere_mod, ere_prog, ere_num)
            call hlp_update(hlp_mod, hlp_prog, hlp_num)

        command "Update" " Update help text"
            call hlp_update(hlp_mod, hlp_prog, hlp_num)

        command "Keys" " Show help for the function keys"
            let hlp_mod  = "lib"
            let hlp_prog = "helpkeys"
            let hlp_num  = 1
            call hlp_read(hlp_mod, hlp_prog, hlp_num)

        command key ("!")
            call ring_bang()

        command key (e,x,q,interrupt) "Quit" " Return to the program"
            let int_flag = 0
            exit menu
    end menu

    close window hlptxtwin

end function
# fg_help()

#####################################################################
function hlp_read(hlp_mod,hlp_prog,hlp_num)
#####################################################################
# This function reads the help text into the p_xhelpd[] array elements
#
    define
        hlp_mod     char(8),    # program name within the module
        hlp_prog    char(8),    # program name within the module
        hlp_num     smallint,   # hlpor number within the program
        n           smallint    # working number

    whenever error continue
        declare d_hlp cursor for
            select * from stxhelpd
              where hlp_module = hlp_mod
                and hlp_program = hlp_prog
                and hlp_number = hlp_num
              order by line_no
        let n = 0
        foreach d_hlp into m_xhelpd.*
            let n = n + 1
            if n > 100
            then
                let n = n - 1
                close d_hlp
                exit foreach
            end if
            let p_xhelpd[n].hlp_text = m_xhelpd.hlp_text
            if n < 11
            then
                display p_xhelpd[n].* to s_xhelpd[n].*
                attribute(red)
            end if
        end foreach
        let rec1_cnt = n

        # clear out old lines from the screen
        for n = (rec1_cnt + 1) to 10
            display " " to s_xhelpd[n].hlp_text
        end for
        return
end function
# hlp_read()

#####################################################################
function hlp_update(hlp_mod,hlp_prog,hlp_num)
#####################################################################
# This function updates the help text displayed on the screen
#
    define
        hlp_mod     char(8),    # program name within the module
        hlp_prog    char(8),    # program name within the module
        hlp_num     smallint,   # hlpor number within the program
        n           smallint    # working number

    display " Update:  [ESC] to Store  [DEL] to Cancel" at 1,1
    display " Enter changes into form" at 2,1
    call set_count(rec1_cnt)
    input array p_xhelpd without defaults from s_xhelpd.*
    if int_flag != 0
    then
        call hlp_read(hlp_mod, hlp_prog, hlp_num)
        let int_flag = 0
    else
        let rec1_cnt = arr_count()
        delete from stxhelpd
          where hlp_module = hlp_mod
            and hlp_program = hlp_prog
            and hlp_number = hlp_num
        for n = 1 to rec1_cnt
            insert into stxhelpd
              values(hlp_mod, hlp_prog, hlp_num, n ,p_xhelpd[n].hlp_text)
        end for
    end if
    return
end function
# hlp_update()
