########################################################################
# Copyright (C) 1990
# FourGen Software Technologies, Inc. Edmonds, Washington USA
# Use, modification, duplication, and/or distribution of this
# software is limited to the terms of the software agreement.
# Sccsid:  @(#)  .../lib.4gm/all.4gs/what_per.4gl  1.8  Delta: 9/4/90
########################################################################

database standard

# locals
define
    l_prepared smallint, # Have SQL statements been prepared?
    l_trx_date date,     # last date passed to this routine
    l_per_no char(2),    # last period number found
    l_per_year char(4)   # last period year found

############################################################
function what_period(trx_date)
# returns l_per_no, l_per_year (or nulls for future periods)
############################################################
# This function is passed a transaction date from which it 
# determines the accounting period and year which are 
# returned.
#
    define
        trx_date date,
        sel_date date,
        scratch char(160)

    # Prepare the SQL statement if needed
    if l_prepared = 123
    then else
        let scratch =
          "select period, period_year from stxperdr ",
          "  where start_date <= ? ",
          "    and end_date   >= ? ",
          "    and period     != \"00\" ",
          "    and balanced    = \"Y\" "
        whenever error continue
        prepare get_perd from scratch
        whenever error call error_handler
        declare perd_curs cursor for get_perd
        let l_prepared = 123
        let l_trx_date = null
        let l_per_no = null
        let l_per_year = null
    end if

    # no need to process again if the date
    # is the same as the last invocation of this function.
    if l_trx_date = trx_date
      then return l_per_no, l_per_year
      else let l_trx_date = trx_date
    end if

    # see if we can find a period definition that matches the trx_date
    whenever error continue
    open perd_curs using trx_date, trx_date
    fetch perd_curs into l_per_no, l_per_year
    whenever error call error_handler
    if sqlca.sqlcode != 0
    then
        # if prior to the 1st period, then put into 1st period.
        # else make l_per_no and l_per_year null.
        whenever error continue
        select min(start_date) into sel_date from stxperdr
          where period != "00" and balanced = "Y"
        whenever error call error_handler
        if  sqlca.sqlcode != 0
        then
            # error condition - no rows in stxperdr
            let sqlca.sqlcode = 0
            let l_per_no = ""
            let l_per_year = ""
            return l_per_no, l_per_year
        end if
        if trx_date < sel_date
        then
            # before first period.
            # get its period number and year.
            whenever error continue
            open perd_curs using sel_date, sel_date
            fetch perd_curs into l_per_no, l_per_year
            whenever error call error_handler
            if sqlca.sqlcode != 0
            then
                # error condition - duplicate start dates in stxperdr
                let sqlca.sqlcode = 0
                let l_per_no = ""
                let l_per_year = ""
                return l_per_no, l_per_year
            end if
        else
            # future period.  return nulls
            let l_per_no = ""
            let l_per_year = ""
            return l_per_no, l_per_year
        end if
    end if
    return l_per_no, l_per_year
end function
# what_period()
